# -*- coding: utf-8 -*-

"""
apimaticapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""


class CodeGenSettings(object):

    """Implementation of the 'CodeGenSettings' model.

    APIMatic’s code generation engine has various code generation
    configurations to customise the behaviour and outlook across the generated
    SDKS. This structure encapsulates all settings for CodeGeneration.

    Attributes:
        is_async (bool): Generate asynchronous code for API Calls and
            deserialization
        use_http_method_prefix (bool): Use HTTP Method prefixes for endpoint
            wrappers
        use_model_prefix (bool): Use "Model" postfixes for generated class
            names
        use_enum_prefix (bool): Use "Enum" postfixes for enumerated types
        use_constructors_for_config (bool): TODO: type description here.
        use_common_sdk_library (bool): Use common SDK library to reduce code
            duplication
        generate_interfaces (bool): Generates interfaces for controller
            classes in the generated SDKs
        generate_appveyor_config (bool): Generate Appveyor configuration file
        generate_circle_config (bool): Generate CircleCI configuration file
        generate_jenkins_config (bool): Generate Jenkins configuration file
        generate_travis_config (bool): Generate Travis CI configuration file
        android_use_app_manifest (bool): Use "AndroidManifest.xml" for config
            variables in Android
        ios_use_app_info_plist (bool): Use "App-Info.plist" file for config
            variables in iOS
        ios_generate_core_data (bool): Generate "CoreData" schema and entity
            classes in iOS?
        runscope_enabled (bool): Enable runscope
        collapse_params_to_array (bool): Collect Parameters as arrays
        preserve_parameter_order (bool): Attempts to preserve parameter order
            for endpoints
        append_content_headers (bool): Append JSON/XML accept and content-type
            headers
        model_serialization_is_json (bool): TODO: type description here.
        nullify_404 (bool): Return a null value on HTTP 404
        validate_required_parameters (bool): Validate required parameters to
            be Not Null
        enable_additional_model_properties (bool): Allow models to have
            additional runtime properties
        java_use_properties_config (bool): TODO: type description here.
        use_controller_prefix (bool): Use "Controller" postfixes for generated
            controller classes
        use_exception_prefix (bool): Use Exception Prefixes
        parameter_array_format (str): Parameter Array format with index or
            without
        obj_c_http_client (str): Configure the HTTP client for Objective C
        c_sharp_http_client (str): Configure the HTTP client for C#
        android_http_client (str): Configure the HTTP client for  Android
        node_http_client (str): Configure the HTTP client for node
        php_http_client (str): Configure the HTTP client for PHP
        body_serialization (int): TODO: type description here.
        array_serialization (str): Specify type of array serialisation
        timeout (int): This option specifies the duration (in seconds) after
            which requests would timeout
        enable_logging (bool): Enabling this generates code in the SDKs for
            logging events in the API cycle using a library.
        enable_http_cache (bool): Enabling caching of responses (not available
            in all languages)
        retries (int): Specify number of retries
        retry_interval (int): Specify retry interval in case of failures
        generate_advanced_docs (bool): Generate advanced read me files
        store_timezone_information (bool): Store Timezone information for the
            generation
        enable_php_composer_version_string (bool): Use "Controller" postfixes
            for generated controller classes
        security_protocols (List[str]): Specify Security Protocols
        underscore_numbers (bool): Use underscores before and after numbers
            for underscore case
        use_singleton_pattern (bool): Allow usage of a Singleton Pattern
        disable_linting (bool): Files/dependencies used for linting are not
            generated if this option is enabled
        allow_skipping_ssl_cert_verification (bool): Create a configuration
            option in SDKs to optionally skip certificate verification when
            establishing HTTPS connections.
        apply_customizations (List[str]): Apply Customisations
        do_not_split_words (List[str]): Enabling this will stop splitting of
            words when converting identifiers from API specification to
            language-specific identifiers.
        sort_resources (bool): Sorts resources such as endpoints, endpoint
            groups and models in generated documentation
        enable_global_user_agent (bool): Enable a global user agent

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "is_async": 'isAsync',
        "use_http_method_prefix": 'useHttpMethodPrefix',
        "use_model_prefix": 'useModelPrefix',
        "use_enum_prefix": 'useEnumPrefix',
        "use_constructors_for_config": 'useConstructorsForConfig',
        "use_common_sdk_library": 'useCommonSdkLibrary',
        "generate_interfaces": 'generateInterfaces',
        "generate_appveyor_config": 'generateAppveyorConfig',
        "generate_circle_config": 'generateCircleConfig',
        "generate_jenkins_config": 'generateJenkinsConfig',
        "generate_travis_config": 'generateTravisConfig',
        "android_use_app_manifest": 'androidUseAppManifest',
        "ios_use_app_info_plist": 'iosUseAppInfoPlist',
        "ios_generate_core_data": 'iosGenerateCoreData',
        "runscope_enabled": 'runscopeEnabled',
        "collapse_params_to_array": 'collapseParamsToArray',
        "preserve_parameter_order": 'preserveParameterOrder',
        "append_content_headers": 'appendContentHeaders',
        "model_serialization_is_json": 'modelSerializationIsJSON',
        "nullify_404": 'nullify404',
        "validate_required_parameters": 'validateRequiredParameters',
        "enable_additional_model_properties": 'enableAdditionalModelProperties',
        "java_use_properties_config": 'javaUsePropertiesConfig',
        "use_controller_prefix": 'useControllerPrefix',
        "use_exception_prefix": 'useExceptionPrefix',
        "parameter_array_format": 'parameterArrayFormat',
        "obj_c_http_client": 'objCHttpClient',
        "c_sharp_http_client": 'cSharpHttpClient',
        "android_http_client": 'androidHttpClient',
        "node_http_client": 'nodeHttpClient',
        "php_http_client": 'phpHttpClient',
        "body_serialization": 'bodySerialization',
        "array_serialization": 'arraySerialization',
        "timeout": 'timeout',
        "enable_logging": 'enableLogging',
        "enable_http_cache": 'enableHttpCache',
        "retries": 'retries',
        "retry_interval": 'retryInterval',
        "generate_advanced_docs": 'generateAdvancedDocs',
        "store_timezone_information": 'storeTimezoneInformation',
        "enable_php_composer_version_string": 'enablePhpComposerVersionString',
        "security_protocols": 'securityProtocols',
        "underscore_numbers": 'underscoreNumbers',
        "use_singleton_pattern": 'useSingletonPattern',
        "disable_linting": 'disableLinting',
        "allow_skipping_ssl_cert_verification": 'allowSkippingSSLCertVerification',
        "apply_customizations": 'applyCustomizations',
        "do_not_split_words": 'doNotSplitWords',
        "sort_resources": 'sortResources',
        "enable_global_user_agent": 'enableGlobalUserAgent'
    }

    def __init__(self,
                 is_async=None,
                 use_http_method_prefix=None,
                 use_model_prefix=None,
                 use_enum_prefix=None,
                 use_constructors_for_config=None,
                 use_common_sdk_library=None,
                 generate_interfaces=None,
                 generate_appveyor_config=None,
                 generate_circle_config=None,
                 generate_jenkins_config=None,
                 generate_travis_config=None,
                 android_use_app_manifest=None,
                 ios_use_app_info_plist=None,
                 ios_generate_core_data=None,
                 runscope_enabled=None,
                 collapse_params_to_array=None,
                 preserve_parameter_order=None,
                 append_content_headers=None,
                 model_serialization_is_json=None,
                 nullify_404=None,
                 validate_required_parameters=None,
                 enable_additional_model_properties=None,
                 java_use_properties_config=None,
                 use_controller_prefix=None,
                 use_exception_prefix=None,
                 parameter_array_format=None,
                 obj_c_http_client=None,
                 c_sharp_http_client=None,
                 android_http_client=None,
                 node_http_client=None,
                 php_http_client=None,
                 body_serialization=None,
                 array_serialization=None,
                 timeout=None,
                 enable_logging=None,
                 enable_http_cache=None,
                 retries=None,
                 retry_interval=None,
                 generate_advanced_docs=None,
                 store_timezone_information=None,
                 enable_php_composer_version_string=None,
                 security_protocols=None,
                 underscore_numbers=None,
                 use_singleton_pattern=None,
                 disable_linting=None,
                 allow_skipping_ssl_cert_verification=None,
                 apply_customizations=None,
                 do_not_split_words=None,
                 sort_resources=None,
                 enable_global_user_agent=None):
        """Constructor for the CodeGenSettings class"""

        # Initialize members of the class
        self.is_async = is_async 
        self.use_http_method_prefix = use_http_method_prefix 
        self.use_model_prefix = use_model_prefix 
        self.use_enum_prefix = use_enum_prefix 
        self.use_constructors_for_config = use_constructors_for_config 
        self.use_common_sdk_library = use_common_sdk_library 
        self.generate_interfaces = generate_interfaces 
        self.generate_appveyor_config = generate_appveyor_config 
        self.generate_circle_config = generate_circle_config 
        self.generate_jenkins_config = generate_jenkins_config 
        self.generate_travis_config = generate_travis_config 
        self.android_use_app_manifest = android_use_app_manifest 
        self.ios_use_app_info_plist = ios_use_app_info_plist 
        self.ios_generate_core_data = ios_generate_core_data 
        self.runscope_enabled = runscope_enabled 
        self.collapse_params_to_array = collapse_params_to_array 
        self.preserve_parameter_order = preserve_parameter_order 
        self.append_content_headers = append_content_headers 
        self.model_serialization_is_json = model_serialization_is_json 
        self.nullify_404 = nullify_404 
        self.validate_required_parameters = validate_required_parameters 
        self.enable_additional_model_properties = enable_additional_model_properties 
        self.java_use_properties_config = java_use_properties_config 
        self.use_controller_prefix = use_controller_prefix 
        self.use_exception_prefix = use_exception_prefix 
        self.parameter_array_format = parameter_array_format 
        self.obj_c_http_client = obj_c_http_client 
        self.c_sharp_http_client = c_sharp_http_client 
        self.android_http_client = android_http_client 
        self.node_http_client = node_http_client 
        self.php_http_client = php_http_client 
        self.body_serialization = body_serialization 
        self.array_serialization = array_serialization 
        self.timeout = timeout 
        self.enable_logging = enable_logging 
        self.enable_http_cache = enable_http_cache 
        self.retries = retries 
        self.retry_interval = retry_interval 
        self.generate_advanced_docs = generate_advanced_docs 
        self.store_timezone_information = store_timezone_information 
        self.enable_php_composer_version_string = enable_php_composer_version_string 
        self.security_protocols = security_protocols 
        self.underscore_numbers = underscore_numbers 
        self.use_singleton_pattern = use_singleton_pattern 
        self.disable_linting = disable_linting 
        self.allow_skipping_ssl_cert_verification = allow_skipping_ssl_cert_verification 
        self.apply_customizations = apply_customizations 
        self.do_not_split_words = do_not_split_words 
        self.sort_resources = sort_resources 
        self.enable_global_user_agent = enable_global_user_agent 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        is_async = dictionary.get("isAsync") if "isAsync" in dictionary.keys() else None
        use_http_method_prefix = dictionary.get("useHttpMethodPrefix") if "useHttpMethodPrefix" in dictionary.keys() else None
        use_model_prefix = dictionary.get("useModelPrefix") if "useModelPrefix" in dictionary.keys() else None
        use_enum_prefix = dictionary.get("useEnumPrefix") if "useEnumPrefix" in dictionary.keys() else None
        use_constructors_for_config = dictionary.get("useConstructorsForConfig") if "useConstructorsForConfig" in dictionary.keys() else None
        use_common_sdk_library = dictionary.get("useCommonSdkLibrary") if "useCommonSdkLibrary" in dictionary.keys() else None
        generate_interfaces = dictionary.get("generateInterfaces") if "generateInterfaces" in dictionary.keys() else None
        generate_appveyor_config = dictionary.get("generateAppveyorConfig") if "generateAppveyorConfig" in dictionary.keys() else None
        generate_circle_config = dictionary.get("generateCircleConfig") if "generateCircleConfig" in dictionary.keys() else None
        generate_jenkins_config = dictionary.get("generateJenkinsConfig") if "generateJenkinsConfig" in dictionary.keys() else None
        generate_travis_config = dictionary.get("generateTravisConfig") if "generateTravisConfig" in dictionary.keys() else None
        android_use_app_manifest = dictionary.get("androidUseAppManifest") if "androidUseAppManifest" in dictionary.keys() else None
        ios_use_app_info_plist = dictionary.get("iosUseAppInfoPlist") if "iosUseAppInfoPlist" in dictionary.keys() else None
        ios_generate_core_data = dictionary.get("iosGenerateCoreData") if "iosGenerateCoreData" in dictionary.keys() else None
        runscope_enabled = dictionary.get("runscopeEnabled") if "runscopeEnabled" in dictionary.keys() else None
        collapse_params_to_array = dictionary.get("collapseParamsToArray") if "collapseParamsToArray" in dictionary.keys() else None
        preserve_parameter_order = dictionary.get("preserveParameterOrder") if "preserveParameterOrder" in dictionary.keys() else None
        append_content_headers = dictionary.get("appendContentHeaders") if "appendContentHeaders" in dictionary.keys() else None
        model_serialization_is_json = dictionary.get("modelSerializationIsJSON") if "modelSerializationIsJSON" in dictionary.keys() else None
        nullify_404 = dictionary.get("nullify404") if "nullify404" in dictionary.keys() else None
        validate_required_parameters = dictionary.get("validateRequiredParameters") if "validateRequiredParameters" in dictionary.keys() else None
        enable_additional_model_properties = dictionary.get("enableAdditionalModelProperties") if "enableAdditionalModelProperties" in dictionary.keys() else None
        java_use_properties_config = dictionary.get("javaUsePropertiesConfig") if "javaUsePropertiesConfig" in dictionary.keys() else None
        use_controller_prefix = dictionary.get("useControllerPrefix") if "useControllerPrefix" in dictionary.keys() else None
        use_exception_prefix = dictionary.get("useExceptionPrefix") if "useExceptionPrefix" in dictionary.keys() else None
        parameter_array_format = dictionary.get("parameterArrayFormat") if dictionary.get("parameterArrayFormat") else None
        obj_c_http_client = dictionary.get("objCHttpClient") if dictionary.get("objCHttpClient") else None
        c_sharp_http_client = dictionary.get("cSharpHttpClient") if dictionary.get("cSharpHttpClient") else None
        android_http_client = dictionary.get("androidHttpClient") if dictionary.get("androidHttpClient") else None
        node_http_client = dictionary.get("nodeHttpClient") if dictionary.get("nodeHttpClient") else None
        php_http_client = dictionary.get("phpHttpClient") if dictionary.get("phpHttpClient") else None
        body_serialization = dictionary.get("bodySerialization") if dictionary.get("bodySerialization") else None
        array_serialization = dictionary.get("arraySerialization") if dictionary.get("arraySerialization") else None
        timeout = dictionary.get("timeout") if dictionary.get("timeout") else None
        enable_logging = dictionary.get("enableLogging") if "enableLogging" in dictionary.keys() else None
        enable_http_cache = dictionary.get("enableHttpCache") if "enableHttpCache" in dictionary.keys() else None
        retries = dictionary.get("retries") if dictionary.get("retries") else None
        retry_interval = dictionary.get("retryInterval") if dictionary.get("retryInterval") else None
        generate_advanced_docs = dictionary.get("generateAdvancedDocs") if "generateAdvancedDocs" in dictionary.keys() else None
        store_timezone_information = dictionary.get("storeTimezoneInformation") if "storeTimezoneInformation" in dictionary.keys() else None
        enable_php_composer_version_string = dictionary.get("enablePhpComposerVersionString") if "enablePhpComposerVersionString" in dictionary.keys() else None
        security_protocols = dictionary.get("securityProtocols") if dictionary.get("securityProtocols") else None
        underscore_numbers = dictionary.get("underscoreNumbers") if "underscoreNumbers" in dictionary.keys() else None
        use_singleton_pattern = dictionary.get("useSingletonPattern") if "useSingletonPattern" in dictionary.keys() else None
        disable_linting = dictionary.get("disableLinting") if "disableLinting" in dictionary.keys() else None
        allow_skipping_ssl_cert_verification = dictionary.get("allowSkippingSSLCertVerification") if "allowSkippingSSLCertVerification" in dictionary.keys() else None
        apply_customizations = dictionary.get("applyCustomizations") if dictionary.get("applyCustomizations") else None
        do_not_split_words = dictionary.get("doNotSplitWords") if dictionary.get("doNotSplitWords") else None
        sort_resources = dictionary.get("sortResources") if "sortResources" in dictionary.keys() else None
        enable_global_user_agent = dictionary.get("enableGlobalUserAgent") if "enableGlobalUserAgent" in dictionary.keys() else None
        # Return an object of this model
        return cls(is_async,
                   use_http_method_prefix,
                   use_model_prefix,
                   use_enum_prefix,
                   use_constructors_for_config,
                   use_common_sdk_library,
                   generate_interfaces,
                   generate_appveyor_config,
                   generate_circle_config,
                   generate_jenkins_config,
                   generate_travis_config,
                   android_use_app_manifest,
                   ios_use_app_info_plist,
                   ios_generate_core_data,
                   runscope_enabled,
                   collapse_params_to_array,
                   preserve_parameter_order,
                   append_content_headers,
                   model_serialization_is_json,
                   nullify_404,
                   validate_required_parameters,
                   enable_additional_model_properties,
                   java_use_properties_config,
                   use_controller_prefix,
                   use_exception_prefix,
                   parameter_array_format,
                   obj_c_http_client,
                   c_sharp_http_client,
                   android_http_client,
                   node_http_client,
                   php_http_client,
                   body_serialization,
                   array_serialization,
                   timeout,
                   enable_logging,
                   enable_http_cache,
                   retries,
                   retry_interval,
                   generate_advanced_docs,
                   store_timezone_information,
                   enable_php_composer_version_string,
                   security_protocols,
                   underscore_numbers,
                   use_singleton_pattern,
                   disable_linting,
                   allow_skipping_ssl_cert_verification,
                   apply_customizations,
                   do_not_split_words,
                   sort_resources,
                   enable_global_user_agent)
