# -*- coding: utf-8 -*-

"""
apimaticapi

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""


class ImportApiVersionViaUrlRequest(object):

    """Implementation of the 'ImportApiVersionViaUrlRequest' model.

    This structure contains details of importing a new API Version

    Attributes:
        version_override (str): The version number with which the new API
            version will be imported. This version number will override the
            version specified in the API specification file.<br>APIMatic
            recommends versioning the API with the [versioning
            scheme](https://docs.apimatic.io/define-apis/basic-settings/#versio
            n) documented in the docs.
        url (str): The URL for the API specification file.<br><br>**Note:**
            This URL should be publicly accessible.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "version_override": 'version_override',
        "url": 'url'
    }

    def __init__(self,
                 version_override=None,
                 url=None):
        """Constructor for the ImportApiVersionViaUrlRequest class"""

        # Initialize members of the class
        self.version_override = version_override 
        self.url = url 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if dictionary is None:
            return None

        # Extract variables from the dictionary
        version_override = dictionary.get("version_override") if dictionary.get("version_override") else None
        url = dictionary.get("url") if dictionary.get("url") else None
        # Return an object of this model
        return cls(version_override,
                   url)
